<?php

//
//  HSession.php
//	$Id: HSession.php,v 1.1 2002/02/06 11:25:39 koyama Exp $
//

/*
 * session level
 */
define('HSLV_FOREVER',		0);
define('HSLV_LOCAL',		50);

define('HSESSION_VARIABLE_NAME', '_hsession_variables');

class HSession {

  // constructor
  function HSession() {
    session_start();
    if ($this->getRg()) {
      session_register(HSESSION_VARIABLE_NAME);
    }
  }

  function clear() {
    session_unregister(HSESSION_VARIABLE_NAME);
  }

  function destroy() {
    session_destroy();
  }

  function isAvail() {
    return session_is_registered(HSESSION_VARIABLE_NAME);
  }

  function setVar($name, $val, $level =HSLV_FOREVER) {
    $vars = HSESSION_VARIABLE_NAME;
    if ($this->getRg()) {
      global $$vars;
      if (!isset($$vars))
	$$vars = array();
      ${$vars}[$name] = array($val, $level);
    }
    else {
      $_SESSION[$vars][$name] = array($val, $level);
    }
  }

  function getVarLevel($name) {
    if (!$this->issetVar($name))
      return;
    $vars = HSESSION_VARIABLE_NAME;
    if ($this->getRg()) {
      global $$vars;
      list($val, $level) = ${$vars}[$name];
    }
    else {
      list($val, $level) = $_SESSION[$vars][$name];
    }
    return array($val, $level);
  }
  
  function getVar($name) {
    list($val, $level) = $this->getVarLevel($name);
    return $val;
  }

  function getLevel($name) {
    list($val, $level) = $this->getVarLevel($name);
    return $level;
  }

  function issetVar($name) {
    $vars = HSESSION_VARIABLE_NAME;
    if ($this->getRg()) {
      global $$vars;
      $result = isset(${$vars}[$name]);
    }
    else {
      $result = isset($_SESSION[$vars][$name]);
    }
    return $result;
  }

  function unsetVar($name) {
    $vars = HSESSION_VARIABLE_NAME;
    if ($this->getRg()) {
      global $$vars;
      unset(${$vars}[$name]);
    }
    else {
      unset($_SESSION[$vars][$name]);
    }
  }

  function getAllInfo() {
    $vars = HSESSION_VARIABLE_NAME;
    $result = array();
    if ($this->getRg()) {
      global $$vars;
      if (isset($$vars)) {
	foreach ($$vars as $name => $pair) {
	  list($val, $level) = $pair;
	  $result[$name] = $level;
	}
      }
    }
    else {
      if (isset($_SESSION[$vars]) && is_array($_SESSION[$vars])) {
	foreach ($_SESSION[$vars] as $name => $pair) {
	  list($val, $level) = $pair;
	  $result[$name] = $level;
	}
      }
    }
    return $result;
  }


  function unsetAllAt($level) {
    $infos = $this->getAllInfo();
    foreach ($infos as $name => $lv) {
      if ($lv == $level) {
	$this->unsetVar($name);
      }
    }
  }

  function unsetAllOver( $level ) {
    $infos = $this->getAllInfo();
    foreach ($infos as $name => $lv) {
      if ($lv > $level) {
	$this->unsetVar($name);
      }
    }
  }

  // utilities
  function getRg() {
    return get_cfg_var('register_globals');
  }
  
  // for debugging
  function dump() {
    $infos = $this->getAllInfo();
    foreach ($infos as $name => $lv) {
      list($val, $level) = $this->getVarLevel($name);
      echo "name: $name, val: $val, level: $level<br>\n";
    }
  }
}

?>
